package com.eteks.test;

/* Copyright (c) 2022 Daniele Lombardi / Daniels118
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import javax.swing.JOptionPane;

import com.eteks.sweethome3d.model.PieceOfFurniture;
import com.eteks.sweethome3d.plugin.Plugin;
import com.eteks.sweethome3d.plugin.PluginAction;

public class VolumeAction extends PluginAction {
	private Plugin plugin;
	
	public VolumeAction(Plugin plugin) {
		this.plugin = plugin;
		putPropertyValue(Property.NAME, "Compute volume");
        putPropertyValue(Property.MENU, "Tools");
        setEnabled(true);
	}
	
	@Override
	public void execute() {
		float volumeInCm3 = 0;
        // Compute the sum of the volume of the bounding box of 
        // each movable piece of furniture in home
        for (PieceOfFurniture piece : plugin.getHome().getFurniture()) {
            if (piece.isMovable()) {
                volumeInCm3 += piece.getWidth() 
                               * piece.getDepth() 
                               * piece.getHeight();
            }
        }
        
        // Display the result in a message box (\u00b3 is for 3 in supercript)
        String message = String.format(
            "The maximum volume of the movable furniture in home is %.2f m\u00b3.", 
            volumeInCm3 / 1000000);
        JOptionPane.showMessageDialog(null, message);
	}

}
